/*class TimeZoneParse {
    constructor(datastr) {
        this.init(datastr);
    }
*/	

    init(data) {
        this.DEFAULT_CHANGEOVER_TIME = 7200000; // Default: 02:00:00
        this.validParse = false;
        this.noDST = false;
        this.startDates = [1, 1, 0];
        this.startTime = this.DEFAULT_CHANGEOVER_TIME;
        this.endDates = [1, 1, 0];
        this.endTime = this.DEFAULT_CHANGEOVER_TIME;
        this.currentOffset = 0;

        this.TZ = "";
        this.data = data;
        this.maxOffset = data.length;
        this.parse();
        this.setTzName();
    }

    parse() {
        this.stdName = this.parseTimezoneName();
        if (this.stdName === null) {
            this.throwParseException("invalid standard timezone", this.currentOffset);
        }

        this.stdOffsetMS = this.parseTimezoneOffset(false);

        this.dstName = this.parseTimezoneName();
        if (this.dstName === null) {
            if (this.currentOffset < this.maxOffset) {
                this.throwParseException("invalid data encountered", this.currentOffset);
            }
            this.noDST = true;
            this.validParse = true;
            return this.validParse;
        }

        const tmpOffset = this.currentOffset;
        this.dstOffsetMS = this.parseTimezoneOffset(true);
        if (tmpOffset === this.currentOffset) {
            this.dstOffsetMS = this.stdOffsetMS - 3600000; // default: 1 hour ahead
        }

        if (this.currentOffset >= this.maxOffset || this.data[this.currentOffset++] !== ',') {
            this.throwParseException("not enough information after dst name", this.currentOffset);
        }

        this.parseDates(this.startDates);
        if (this.currentOffset < this.maxOffset && this.data[this.currentOffset++] === '/') {
            this.startTime = this.parseTime(false);
        }

        if (this.currentOffset >= this.maxOffset || this.data[this.currentOffset++] !== ',') {
            this.throwParseException("missing end dst boundary date", this.currentOffset);
        }
        this.parseDates(this.endDates);
        if (this.currentOffset < this.maxOffset && this.data[this.currentOffset++] === '/') {
            this.endTime = this.parseTime(false);
        }
        this.validParse = true;

        return this.validParse;
    }

    setTzName() {
        if (!this.validParse) {
            this.throwParseException("Parse invalid false.", 28);
        }

        const fs = require('fs');
        const path = require('path');
        const mFile = path.join(__dirname, 'date_time_zonespec.csv');

        let z;
        try {
            z = fs.readFileSync(mFile, 'utf8').split("\n");
        } catch (error) {
            console.log("could not open file for read");
            return;
        }

        const zones = [];
        z.forEach(ms => {
            if (ms.split(",").length > 3) {
                zones.push(ms.replace(/"/g, "").split(","));
            }
        });

        for (let i = 0; i < zones.length; i++) {
            if (this.noDST) {
                const az = zones[i][5];
                const os = (this.stdOffsetMS / (60 * 60 * 1000)).toString();
                if (zones[i][1] === this.stdName && az.includes(os)) { //FIXME: time zone
                    this.TZ = zones[i][0];
                    break;
                }
            } else {
                if (zones[i][1] === this.stdName && zones[i][3] === this.dstName) {
                    const st = zones[i][7].split(";");
                    const et = zones[i][9].split(";");
                    const az = zones[i][5];
                    const os = (this.stdOffsetMS / (60 * 60 * 1000)).toString();
                    if (!(st.length === 3 && et.length === 3)) return;

                    if (this.startDates[0] === parseInt(st[2]) &&
                        this.startDates[1] === parseInt(st[0]) &&
                        this.startDates[2] === parseInt(st[1])) {
                        if (this.endDates[0] === parseInt(et[2]) &&
                            this.endDates[1] === parseInt(et[0]) &&
                            this.endDates[2] === parseInt(et[1])) {
                            if (az.includes(os)) { //FIXME: time zone
                                this.TZ = zones[i][0];
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

    // Placeholder methods for the missing implementations
    parseTimezoneName() {
        // Implement the logic to parse timezone name
    }

    parseTimezoneOffset(isDst) {
        // Implement the logic to parse timezone offset
    }

    parseDates(dates) {
        // Implement the logic to parse dates
    }

    parseTime(isDst) {
        // Implement the logic to parse time
    }

    throwParseException(message, offset) {
        throw new Error(`${message} at offset ${offset}`);
    }
//}
/*
class TimeZoneParse {
    constructor(data) {
        this.data = data;
        this.currentOffset = 0;
        this.maxOffset = data.length;
    }
*/
    parseDates(date) {
        if (this.currentOffset >= this.maxOffset || this.data[this.currentOffset++] !== 'M') {
            this.throwParseException("invalid dst boundary date", this.currentOffset);
        }
        const tmpOffset = this.currentOffset;
        date[0] = this.parseNumber();
        if (tmpOffset === this.currentOffset || date[0] < 1 || date[0] > 12) {
            this.throwParseException("invalid dst month", this.currentOffset);
        }
        if (this.currentOffset >= this.maxOffset || this.data[this.currentOffset++] !== '.') {
            this.throwParseException("invalid dst boundary char", this.currentOffset);
        }
        const tmpOffsetWeek = this.currentOffset;
        date[1] = this.parseNumber();
        if (tmpOffsetWeek === this.currentOffset || date[1] < 1 || date[1] > 5) {
            this.throwParseException("invalid dst boundary week", this.currentOffset);
        }
        if (this.currentOffset >= this.maxOffset || this.data[this.currentOffset++] !== '.') {
            this.throwParseException("invalid dst boundary char", this.currentOffset);
        }
        const tmpOffsetDay = this.currentOffset;
        date[2] = this.parseNumber();
        if (tmpOffsetDay === this.currentOffset || date[2] < 0 || date[2] > 6) {
            this.throwParseException("invalid dst boundary day", this.currentOffset);
        }
    }

    parseTimezoneName() {
        let follow = this.currentOffset;
        if (follow + 3 > this.maxOffset) return null;
        if (this.data[this.currentOffset] === ':') {
            return null;
        }

        const nameLength = follow + 3;
        while (follow < nameLength) {
            const look = this.data[follow];
            if (/[a-zA-Z]/.test(look)) {
                if (look === '-' || look === '+' || look === ',') {
                    break;
                }
            } else {
                break;
            }
            follow++;
        }
        if (follow !== nameLength) return null;
        const ret = this.data.substring(this.currentOffset, follow);
        this.currentOffset = follow;
        return ret;
    }

    parseNumber() {
        let follow = this.currentOffset;
        let value = 0;
        while (follow < this.maxOffset) {
            const look = this.data[follow];
            if (look >= '0' && look <= '9') {
                value = value * 10 + (look.charCodeAt(0) - '0'.charCodeAt(0));
            } else {
                break;
            }
            follow++;
        }
        this.currentOffset = follow;
        return value;
    }

    parseTimezoneOffset(isOptional) {
        if (this.currentOffset >= this.maxOffset) {
            if (!isOptional) {
                this.throwParseException("Missing non-optional timezone offset", this.currentOffset);
            }
            return 0;
        }
        const optionalSign = this.data[this.currentOffset];
        let negate = false;
        if (optionalSign === '+' || optionalSign === '-') {
            if (optionalSign === '-') negate = true;
            isOptional = false; // If the + is here, we need a number.
            this.currentOffset++;
        }

        const ret = this.parseTime(isOptional);
        return negate ? -ret : ret;
    }

    throwParseException(message, offset) {
        throw new Error(`${message} at offset ${offset}`);
    }

    parseTime(isOptional) {
        // Implement the parseTime method as needed
        return 0; // Placeholder return value
    }
//}

/*class TimeZoneParse {
    constructor() {
        this.currentOffset = 0; // Initialize as needed
        this.maxOffset = 0; // Initialize as needed
        this.data = ""; // Initialize as needed
        this.validParse = true; // Initialize as needed
    }
*/
    parseTime(isOptional) {
        let sec = 0;
        let min = 0;
        let tmpOffset = this.currentOffset;
        const hour = this.parseNumber();
        
        if (tmpOffset === this.currentOffset) {
            if (!isOptional) {
                this.throwParseException("Missing non-optional hours", this.currentOffset);
            }
            return 0;
        }
        
        if (hour < 0 || hour > 23) this.throwParseException("Invalid hour", this.currentOffset);
        
        if (this.currentOffset < this.maxOffset && this.data[this.currentOffset] === ':') {
            tmpOffset = ++this.currentOffset;
            min = this.parseNumber();
            if (tmpOffset === this.currentOffset) {
                this.throwParseException("Missing non-optional minutes", this.currentOffset);
            }
            if (min < 0 || min > 59) this.throwParseException("Invalid minute", this.currentOffset);
            
            if (this.currentOffset < this.maxOffset && this.data[this.currentOffset] === ':') {
                tmpOffset = ++this.currentOffset;
                sec = this.parseNumber();
                if (tmpOffset === this.currentOffset) {
                    this.throwParseException("Missing non-optional seconds", this.currentOffset);
                }
                if (sec < 0 || sec > 59) this.throwParseException("Invalid second", this.currentOffset);
            }
        }
        
        const ret = ((hour * 3600) + (min * 60) + sec) * 1000;
        return ret;
    }

    throwParseException(msg, obj) {
        console.error(msg + " : " + obj);
        this.validParse = false;
        throw new Error(msg);
    }


//}


