/*
(\w+)([+-]?\d+)(\w+([+-]?\d+)?)?
Edit by TF to process TZ offsets with hh:mm format in REGEX
parsePosixTZ accepts a POSIX time zone string and returns an object like this:

> parsePosixTZ('PST8PDT,M3.2.0,M11.1.0')
{ stdAbbr: 'PST',
  stdOffset: 480,
  dst: true,
  dstAbbr: 'PDT',
  dstOffset: 420,
  dstStart: { month: 3, week: 2, day: 0, hour: 2, minute: 0, second: 0 },
  dstEnd: { month: 11, week: 1, day: 0, hour: 2, minute: 0, second: 0 } }
  */
function parsePosixTZ(tz) {
  const result = {
    stdAbbr: null,
    stdOffset: 0,
    dst: false,
    dstAbbr: null,
    dstOffset: null,
    dstStart: null,
    dstEnd: null
  };
    console.log(tz);
  const parts = tz.split(',');
    console.log(parts);
  const localTZ = parts[0];

 //const LOCAL_TZ_RE = /(\w+)([+-]?\d+)(\w+([+-]?\d+)?)?/;
 //The OR whould match a HH or a HH:MM offset
 // const LOCAL_TZ_RE = /(\w+)([+-]?\d+:\d+|[+-]?\d+)(\w+([+-]?\d+:\d+|[+-]?\d+)?)?/;
  const LOCAL_TZ_RE = /([A-Za-z]+)([+-]?[0-2]?[0-9]:[0-5][0-9]|[+-]?[0-2]?[0-9])?([A-Za-z]+)?([+-]?[0-2]?[0-9]:[0-5][0-9]|[+-]?[0-2]?[0-9])?/
  // Groups:           1    2         	            3   4
  // 1: stdAbbr
  // 2: stdOffset can be +- hh OR +-hh:mm
  // 3: dstAbbr
  // 4: dstOffset

  const match = LOCAL_TZ_RE.exec(localTZ);
    console.log(match);
  if (!match) {
    return null;
  }

  result.stdAbbr = match[1];
  console.log('match2',match[2]);
  result.stdOffset = match[2] ? parseOffset(match[2]) : 0;

  if (match[3]) {
    result.dst = true;
    result.dstAbbr = match[3];
    result.dstOffset = match[4] ? parseOffset(match[4]) : result.stdOffset + 60;
    result.dstStart = parseTransition(parts[1]);
    result.dstEnd = parseTransition(parts[2]);
  }

  return result;



}

  function parseOffset(offset) {
	  console.log('parseOffset',offset);
    // TODO: support hh:mm:ss
	// sign hh : mm
	//split offset on ':'
	var arrOffset = offset.split(':')
	console.log(arrOffset);
    let hours = Number(arrOffset[0]);
	let minute = Number(arrOffset[1]);
	let allminutes = hours*60;
	if ( !isNaN(minute) ) allminutes += minute;
	console.log( hours, minute, allminutes);

    if (hours) {
      allminutes *= -1;
    }
	
	
    return allminutes;
  }
  
  
  function parseTransition(transition) {
    if (transition[0] === 'M') {
      const parts = transition.slice(1).split('/');

      const [month, week, day] = parts[0].split('.');

      const time = {
        hour: 2,
        minute: 0,
        second: 0
      };

      if (parts[1]) {
        const timeParts = parts[1].split(':');

        time.hour = Number(timeParts[0]);
        time.minute = timeParts[1] ? Number(timeParts[1]) : 0;
        time.second = timeParts[2] ? Number(timeParts[2]) : 0;
      }

      return Object.assign(
        {
          month: Number(month),
          week: Number(week),
          day: Number(day)
        },
        time
      );
    }

    // TODO: support J

    return null;
  }