/* original file converted to JSON to be imported to a indexeddb database */
/*
let TZtext = '{ "timezones" : [' +
'{ "TZName":"GMT" , "ZString":"Z{DST, 5, 1, 03, 01, 060 }{STD, 5, 1, 10, 02, 000 }" },' +" },' +
{ "TZName":"BST" , "ZString":"Z{DST, 5, 1, 03, 01, 060 }{STD, 5, 1, 10, 02, 000 }" }' +" },' +
 ]}';

const TZJSON = JSON.parse(TZtext);
*/
/*
// This file contains POSIX 1003.1 section 8 TZ strings
// used by wclock.exe <www.di-mgt.com.au/wclock/>

// Format:-
// 		[ID-string ]
// TZ=posix-tz-string

// Not authoritative. Use at your own risk.
// Feel free to edit and add your own entries
// Errors and suggestions to <https://www.di-mgt.com.au/contact>

// ---------------------------------------------------
// Do NOT remove or change the Version or UTC entries
	[Version ]
Number=1650
Date=2022-10-31T17:38Z

	[UTC ]
TZ=GMT0
// ---------------------------------------------------
*/
// -----YOU ARE FREE TO EDIT BELOW THIS LINE-----

// Eastern states of Australia changed in 2008
let TZtext = '{ "timezones" : [' + 

'{ "TZName":"Australia/Sydney" , "ZString":"AEST-10AEDT-11,M10.1.0,M4.1.0" },' +
'{ "TZName":"Australia/Adelaide" , "ZString":"ACST-9:30ACDT,M10.1.0,M4.1.0" },' +
'{ "TZName":"Australia/Hobart" , "ZString":"AEST-10AEDT-11,M10.1.0,M4.1.0" },' +
'{ "TZName":"Australia/Brisbane" , "ZString":"EST-10" },' +
'{ "TZName":"Australia/Darwin" , "ZString":"CST-9:30" },' +
// West Australia reverted back to no DST in 2009" },' +
'{ "TZName":"Australia/Perth" , "ZString":"AWST-8" },' +
// Odd zones" },' +
'{ "TZName":"Australia/Eucla" , "ZString":"ACWST-8:45" },' +
'{ "TZName":"Australia/Broken_Hill" , "ZString":"ACST-9:30ACDT,M10.1.0,M4.1.0" },' +
'{ "TZName":"Australia/Lord_Howe" , "ZString":"LHST-10:30LHDT,M11.1.0,M4.1.0" },' +
// Bits of Australia in the Indian and Pacific oceans" },' +
'{ "TZName":"Indian/Christmas" , "ZString":"CXT-7" },' +
'{ "TZName":"Indian/Cocos" , "ZString":"CCT-6:30" },' +
'{ "TZName":"Pacific/Norfolk" , "ZString":"NFT-11" },' +
// New Zealand changed in 2008" },' +
'{ "TZName":"Pacific/Auckland" , "ZString":"NZST-12NZDT,M9.5.0/2,M4.1.0/3" },' +
'{ "TZName":"Pacific/Port_Moresby" , "ZString":"PGT-10" },' +
'{ "TZName":"Asia/Delhi" , "ZString":"IST-05:30" },' +
// Correct notation is [Continent/City]
// but keep "India" here for compatability with old versions" },' +
'{ "TZName":"Asia/India" , "ZString":"IST-05:30" },' +
// Corrected spelling of Kathmandu 2017-02-08 (thanks, Brendan)" },' +
'{ "TZName":"Asia/Kathmandu" , "ZString":"NPT-5:45" },' +
'{ "TZName":"Asia/Bahrain" , "ZString":"AST-3" },' +
'{ "TZName":"Asia/Dubai" , "ZString":"GST-4" },' +
// Baku abolished DST in 2016" },' +
'{ "TZName":"Asia/Baku" , "ZString":"AZT-4" },' +
'{ "TZName":"Asia/Karachi" , "ZString":"PKT-5" },' +
'{ "TZName":"Asia/Almaty" , "ZString":"ALMT-6" },' +
'{ "TZName":"Asia/Bangkok" , "ZString":"ICT-7" },' +
'{ "TZName":"Asia/Jakarta" , "ZString":"WIT-7" },' +
'{ "TZName":"Asia/Singapore" , "ZString":"SGT-8" },' +
'{ "TZName":"Asia/Hong_Kong" , "ZString":"HKT-8" },' +
'{ "TZName":"Asia/Beijing" , "ZString":"CST-8" },' +
'{ "TZName":"Asia/Taipei" , "ZString":"CST-8" },' +
'{ "TZName":"Asia/Tokyo" , "ZString":"JST-9" },' +
// Russia on permanent DST after March 2011" },' +
// Moved back to permanent standard time October 2014" },' +
'{ "TZName":"Asia/Kamchatka" , "ZString":"PETT-12" },' +
// Israel on fixed rule for DST as of 2013" },' +
// DST starts on the Friday before the last Sunday in March" },' +
// Thanks to Ron Varburg for this rule" },' +
'{ "TZName":"Asia/Jerusalem" , "ZString": "IST-2IDT,M3.4.4/26,M10.5.0" },' +
'{ "TZName":"Europe/London" , "ZString":"GMT0BST,M3.5.0/1,M10.5.0/2" },'  +
//-----------------------------------------------//
// 2020-05-02 added various extra European cities
// Western European Time" },' +
'{ "TZName":"Europe/Dublin" , "ZString":"GMT0IST,M3.5.0/1,M10.5.0/2" },' +
'{ "TZName":"Europe/Lisbon" , "ZString":"WET0WEST,M3.5.0/1,M10.5.0/2" },' +
// Central European Time" },' +
'{ "TZName":"Europe/Paris" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Berlin" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Brussels" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Amsterdam" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Madrid" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Rome" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Vienna" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Prague" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Budapest" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Warsaw" , "ZString":"CET-1CEST,M3.5.0/2,M10.5.0/3" },' +
// Eastern European Time" },' +
'{ "TZName":"Europe/Athens" , "ZString":"EET-2EEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Bucharest" , "ZString":"EET-2EEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Sofia" , "ZString":"EET-2EEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Helsinki" , "ZString":"EET-2EEST,M3.5.0/2,M10.5.0/3" },' +
'{ "TZName":"Europe/Kiev" , "ZString":"EET-2EEST,M3.5.0/2,M10.5.0/3" },' +
// Turkey changed to permanent DST September 2016  " },' +
'{ "TZName":"Europe/Istanbul" , "ZString":"TRT-3" },' +
// Russia on permanent DST after March 2011" },' +
// Moved back to permanent standard time October 2014" },' +
'{ "TZName":"Europe/Moscow" , "ZString":"MSK-3" },' +
'{ "TZName":"Africa/Nairobi" , "ZString":"EAT-3" },' +
// Egypt cancelled DST from April 2015 " },' +
'{ "TZName":"Africa/Cairo" , "ZString":"EET-2" },' +
'{ "TZName":"Africa/Johannesburg" , "ZString":"SAST-2" },' +
'{ "TZName":"Africa/Lagos" , "ZString":"WAT-1" },' +
'{ "TZName":"Africa/Dakar" , "ZString":"GMT0" },' +
// US & Canada changed DST from March 2007" },' +
// --begins 2nd Sun in March and ends 1st Sun in Nov" },' +
// --all switch at 2:00 local time" },' +
'{ "TZName":"America/New_York" , "ZString":"EST5EDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Chicago" , "ZString":"CST6CDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Denver" , "ZString":"MST7MDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Los_Angeles" , "ZString":"PST8PDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Anchorage" , "ZString":"AKST9AKDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Phoenix" , "ZString":"MST7" },' +
'{ "TZName":"America/Regina" , "ZString":"CST6" },' +
// NB Honolulu is under `Pacific'" },' +
'{ "TZName":"Pacific/Honolulu" , "ZString":"HST10" },' +
//---------------------------------" },' +
// 2020-05-02 added Canadian cities to match equivalent US zones" },' +
'{ "TZName":"America/Halifax" , "ZString":"AST4ADT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Toronto" , "ZString":"EST5EDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Winnipeg" , "ZString":"CST6CDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Edmonton" , "ZString":"MST7MDT,M3.2.0,M11.1.0" },' +
'{ "TZName":"America/Vancouver" , "ZString":"PST8PDT,M3.2.0,M11.1.0" },' +
// Yukon goes to permanent DST from 2020" },' +
'{ "TZName":"America/Whitehorse" , "ZString":"MST7" },' +
// A special for eastern Canadians (cheers, Chris)" },' +
// --Newfoundland switches at 00:01 local time" },' +
'{ "TZName":"America/St_Johns" , "ZString":"NST03:30NDT,M3.2.0/0:01,M11.1.0/0:01" },' +
// Updated Venezuela 2016-05-01" },' +
'{ "TZName":"America/Caracas" , "ZString":"VET4" },' +
'{ "TZName":"America/Buenos_Aires" , "ZString":"ART3" },' +
// Mexico abolished DST 2022-10-28" },' +
'{ "TZName":"America/Mexico_City" , "ZString":"" },' +
// Added Costa Rica 2013-09-19" },' +
'{ "TZName":"America/Costa_Rica" , "ZString":"CST6" },' +
// Chile reintroduced DST in 2016, changed in 2019" },' +
'{ "TZName":"America/Santiago" , "ZString":"CLT4CLST,M9.1.0/4:00,M4.1.0/3:00" },' +
'{ "TZName":"America/Sao_Paulo" , "ZString":"BRT3" },' +
// Brazil no longer has DST changes - decree signed 2019-04-25

// Added Bolivia, Paraguay and Uruguay 2011-01-02" },' +
'{ "TZName":"America/La_Paz" , "ZString":"BOT4" },' +
// Paraguay changed 2013 DST off on first Sun>=22 Mar, so TZ only approximate// +
'{ "TZName":"America/Asuncion" , "ZString":"PYT4PYST,M10.1.0/0:01,M3.4.0/1:00" },' +
'{ "TZName":"America/Montevideo" , "ZString":"UYT3UYST,M10.1.0,M3.2.0" },' +
// Miscellaneous time zones added 2017-02-08" },' +
//------------------------------------------" },' +
// Eastern Greenland Ittoqqortoormiit (?check DST transition times?)" },' +
'{ "TZName":"America/Scoresbysund" , "ZString":"EGT1EGDT,M3.5.0/0,M10.5.0/1" },' +
'{ "TZName":"Atlantic/Cape_Verde" , "ZString":"CVT1" },' +
'{ "TZName":"Atlantic/South_Georgia" , "ZString":"GST2" },' +
'{ "TZName":"Pacific/Noumea" , "ZString":"NCT-11" },' +
// Tuvalu" },' + 
'{ "TZName":"Pacific/Funafuti" , "ZString":"TVT-12" }' +
' ]}';


const TZJSON = JSON.parse(TZtext);

//function to convert the POSIX string to the old Arduino TZ rule used in KitST Clock//
// GMT0BST,M3.5.0/1,M10.5.0/2 == Z{DST, 5, 1, 03, 01, 060 }{STD, 5, 1, 10, 02, 000 } //
/* GMT Standard Time is 00:00 later than Coordinated Universal Time.
Start: The Last Sunday of March at 01:00
End: The Last Sunday of October at 02:00 */


